/*
	SambaScanner - A tool to scan Samba networks for files.
	Copyright (C) 2005-2007 Johannes Bauer
	
	This file is part of SambaScanner.

    SambaScanner is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; this program is ONLY licensed under
	version 2 of the License, later versions are explicitly excluded.

    SambaScanner is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with SambaScanner; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Johannes Bauer
	Mussinanstr. 140
	92318 Neumarkt/Opf.
	JohannesBauer@gmx.de
*/

#include <signal.h>
#include <pthread.h>
#include <unistd.h>
#include <stdlib.h>

#include "ProcessTable.h"
#include "PThreads.h"

#define PT_CONCURRENT_THREADS		50

static void* ProcessTable_Thread(void *Data) {
	long Number = ((long)Data) % 3;
	if (Number == 0) {
		while (1) {
			struct Process *Entry;
			ProcessTable_Rewind();
			while ((Entry = ProcessTable_Next()));
			usleep(rand() % 100);
		}
	} else if (Number == 1) {
		while (1) {
			ProcessTable_CreatePreliminary(1.0, 2.0);
			ProcessTable_UpdateEntry_ThreadID((pthread_t)0);
			ProcessTable_FinishEntry(rand() % 30000);
			usleep(rand() % 100);
		}
	} else if (Number == 2) {
		while (1) {
			struct Process *Entry;
			ProcessTable_Rewind();
			Entry = ProcessTable_Next();
			if (!Entry) ProcessTable_RemoveEntry(Entry);
			while (ProcessTable_Next());
			usleep(rand() % 100);
		}
	}
	pthread_exit(NULL);
	return NULL;
}

void ProcessTable_Stresstest() {
	pthread_t Threads[PT_CONCURRENT_THREADS];
	long i;

	for (i = 0; i < PT_CONCURRENT_THREADS; i++) {
		pthread_create_detached(Threads + i, ProcessTable_Thread, (void*)i);
	}

	while (1) sleep(1);
}
